#!/usr/bin/python2.3

import sys
import string
import re

class Record:
	pre = 0
	body = 1
	def __init__(self, line):
		self.id = None
		self.data = ""
		self.state = Record.pre
		self.done = False
		self.initial(line)
	def dump(self):
		print "<record id='%s'><category>%s</category><email>%s</email></record>" % (self.id, self.category, self.email)
	def feed(self, line):
		if line.find("|%s|" % self.id) > 0:
			self.done = True
		self.data = self.data + line
		return self.parse()
	def initial(self, line):
		m = re.match("^(\d+)\|", line)
		if not m or not m.group(1):
			raise RuntimeError("Unable to match input \"%s\": %s" % (line, "No ID found"))
		self.id = m.group(1)
		self.data = line
		tail = line[m.end():]
		if tail.find("|%s|" % self.id) > 0:
			self.done = True
			return self.parse()
	def parse(self):
		(id0,name,link,email,category,body,banner,link,bool,id1,ip,time) = self.data.split('|')
		if id0 != id1:
			raise RuntimeError("Error in record %s: id0 (%s) != id1 (%s)" % (self.id, id0, id1))
		self.link = link 
		self.email = email
		self.banner = banner
		self.category = category
		
get_line = sys.stdin.readline

record = None
try:
	line = get_line()
	counter = 1
	while line:
		#print "<data>%s</data>" % line
		if record:
			record.feed(line)
		else:
			record = Record(line)
		if record.done:
			record.dump()
			record = None
		line = get_line()
		counter = counter + 1
except Exception, e:
	print "Error %s" % e.__str__()
	if record:
		print "Current record data: %s" % record.data
	if counter:
		print "String: %d" % counter
	sys.exit(1)
